stages:
  - test
  - release
  - deploy

# lint:
#   stage: test
#   image: python:3.6
#   script:
#     - pip install flake8
#     - flake8 .
#   except:
#     - master
#     - tags

test:
  stage: test
  image: python:3.6
  script:
    - pip install -r requirements.txt
    - pip install -r requirements-test.txt
    - coverage run -m unittest discover
    - coverage report -m
  coverage: '/TOTAL.+ ([0-9]{1,3}%)/'
  when:
    manual
  except:
    - master
    - tags

semantic_release:
  stage: release
  image: node:12
  variables:
      GITLAB_TOKEN: $CI_TOKEN
  before_script:
      - npm install -g semantic-release @semantic-release/gitlab-config
  script:
      - semantic-release -e @semantic-release/gitlab-config
  only:
      - master

image: google/cloud-sdk:alpine
variables:
  VERSION: "$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"

deploy_production:
  stage: deploy
  environment: Production
  only:
  - master
  script:
    # Handle multiline variables, this seems to be a Gitlab issue
  - PUBSUB_JSON_CREDS_DATA=`echo ${PUBSUB_JSON_CREDS} | tr -d '\r'`


  - sed -i "s|GITLAB_CLOUD_SQL_INSTANCES|$CLOUD_SQL_INSTANCES|g" app.yaml

  - sed -i "s|GITLAB_LOGLEVEL|$LOGLEVEL|g" app.yaml

  - sed -i "s|GITLAB_PUBSUB_CLASSIFIED_TWEET_TOPIC|$PUBSUB_CLASSIFIED_TWEET_TOPIC|g" app.yaml
  - sed -i "s|GITLAB_PUBSUB_JSON_CREDS|$PUBSUB_JSON_CREDS_DATA|g" app.yaml
  - sed -i "s|GITLAB_PUBSUB_PROJECT_ID|$PUBSUB_PROJECT_ID|g" app.yaml
  - sed -i "s|GITLAB_PUBSUB_RESPONSES_TOPIC|$PUBSUB_RESPONSES_TOPIC|g" app.yaml
  - sed -i "s|GITLAB_SQLALCHEMY_MYSQL_URI|$SQLALCHEMY_MYSQL_URI|g" app.yaml
  - sed -i "s|GITLAB_TWITTER_ACCESS_SECRET_VAR|$TWITTER_ACCESS_SECRET|g" app.yaml
  - sed -i "s|GITLAB_TWITTER_ACCESS_TOKEN_VAR|$TWITTER_ACCESS_TOKEN|g" app.yaml
  - sed -i "s|GITLAB_TWITTER_CONSUMER_KEY_VAR|$TWITTER_CONSUMER_KEY|g" app.yaml
  - sed -i "s|GITLAB_TWITTER_CONSUMER_SECRET_VAR|$TWITTER_CONSUMER_SECRET|g" app.yaml
  - sed -i "s|GITLAB_ANGOSTURA_PROXY_URL|$ANGOSTURA_PROXY_URL|g" app.yaml

  - echo $GCP_SERVICE_ACCOUNT > $CI_PIPELINE_ID.json
  - echo "Deploying App..."
  - gcloud auth activate-service-account --key-file $CI_PIPELINE_ID.json
  - gcloud config set app/cloud_build_timeout 2000
  - gcloud --quiet app deploy app.yaml --version=$VERSION --project=$GCP_PROJECT_ID
  after_script:
  - rm $CI_PIPELINE_ID.json
  when:
    manual
